记录一个猪鼻时刻leetcode 39. 组合总和
题目
给你一个 无重复元素 的整数数组 candidates 和一个目标整数 target ,找出 candidates 中可以使数字和为目标数 target 的 所有 不同组合 ,并以列表形式返回。你可以按 任意顺序 返回这些组合。
candidates 中的 同一个 数字可以 无限制重复被选取 。如果至少一个数字的被选数量不同,则两种组合是不同的。
对于给定的输入,保证和为 target 的不同组合数少于 150 个。
示例 1:
输入:candidates = [2,3,6,7], target = 7
输出:[[2,2,3],[7]]
解释:
2 和 3 可以形成一组候选,2 + 2 + 3 = 7 。注意 2 可以使用多次。
7 也是一个候选, 7 = 7 。
仅有这两种组合。
示例 2:
输入: candidates = [2,3,5], target = 8
输出: [[2,2,2,2],[2,3,3],[3,5]]
示例 3:
输入: candidates = [2], target = 1
输出: []
提示:
1 <= candidates.length <= 30
2 <= candidates[i] <= 40
candidates 的所有元素 互不相同
1 <= target <= 40
思路
dp解决,一开始想的是倒序排序,先加大的,大的加爆了再加小的试试。dfs思路倒是不难,但是为了防止加入的子集重复写了个对比。也就是我的第一版代码。剪枝操作就是idx的引入(不引入会TLE),不重复加入无意义的大的就行。后来发现,根本不需要防止重复,本来就是有序的,正常走就不会出错,草。
题解
// 第一版
class Solution {
public List<List<Integer>> list = new ArrayList<>();
public List<Integer> subList = new ArrayList<>();
public List<List<Integer>> combinationSum(int[] candidates, int target) {
Arrays.sort(candidates);
int i = 0, j = candidates.length - 1;
while(i < j) {
int tmp = candidates[i];
candidates[i] = candidates[j];
candidates[j] = tmp;
i++;
j--;
}
dfs(candidates, target, 0, 0);
return list;
}
public boolean isEqual(List<Integer> a, List<Integer> b) {
if (a.size() != b.size()) {return false;}
Collections.sort(a);
for (int i=0;i<a.size();i++) {
if (a.get(i) != b.get(i)) {return false;}
}
return true;
}
public boolean exist(List<Integer> l) {
for (int i=0;i<list.size();i++) {
if (isEqual(list.get(i), l)) {return true;}
}
return false;
}
public void dfs(int[] candidates, int target, int cnt, int idx) {
if (cnt > target) {return;}
else if (cnt == target) {
// 不能图省事这里sort,要不然之后dfs完remove的不是刚加入的
List<Integer> l = new ArrayList<>(subList);
Collections.sort(l);
if (exist(l)) {return;}
// sublist是出入元素的,所以记得加入的是复制过的
list.add(l);
return;
}
for (int i=idx;i<candidates.length;i++) {
subList.add(candidates[i]);
cnt += candidates[i];
dfs(candidates, target, cnt, i);
subList.remove(subList.size() - 1);
cnt -= candidates[i];
}
}
}
// 第二版
class Solution {
public List<List<Integer>> list = new ArrayList<>();
public List<Integer> subList = new ArrayList<>();
public List<List<Integer>> combinationSum(int[] candidates, int target) {
Arrays.sort(candidates);
int i = 0, j = candidates.length - 1;
while(i < j) {
int tmp = candidates[i];
candidates[i] = candidates[j];
candidates[j] = tmp;
i++;
j--;
}
dfs(candidates, target, 0, 0);
return list;
}
public boolean isEqual(List<Integer> a, List<Integer> b) {
if (a.size() != b.size()) {return false;}
Collections.sort(a);
for (int i=0;i<a.size();i++) {
if (a.get(i) != b.get(i)) {return false;}
}
return true;
}
public boolean exist(List<Integer> l) {
for (int i=0;i<list.size();i++) {
if (isEqual(list.get(i), l)) {return true;}
}
return false;
}
public void dfs(int[] candidates, int target, int cnt, int idx) {
if (cnt > target) {return;}
else if (cnt == target) {
// 不能图省事这里sort,要不然之后dfs完remove的不是刚加入的
List<Integer> l = new ArrayList<>(subList);
list.add(l);
return;
}
// idx是剪枝的
for (int i=idx;i<candidates.length;i++) {
subList.add(candidates[i]);
cnt += candidates[i];
dfs(candidates, target, cnt, i);
subList.remove(subList.size() - 1);
cnt -= candidates[i];
}
}
}